unit Unit1;

{$mode objfpc}{$H+}
{$modeswitch AdvancedRecords}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Spin;

type

  { TMyClass }

  TMyClass = class
  private
    FButton1: String;
    FDescription: String;
    FField3: Double;
    FFloatSpinEdit1: String;
    FIsBool: Boolean;
    FName: String;
    FQty: Currency;
    FSpinEdit1: String;
    FValue: Integer;
  published
    property Name: String Index 1 read FName write FName;
    property Value: Integer Index 2 read FValue write FValue;
    property IsBool: Boolean Index 3 read FIsBool write FIsBool;
    property Qty: Currency Index 4 read FQty write FQty;
    property Description: String Index 5 read FDescription write FDescription;
    property SpinEdit1: String Index 6 read FSpinEdit1 write FSpinEdit1;
    property FloatSpinEdit1: String Index 7 read FFloatSpinEdit1 write FFloatSpinEdit1;
    property Button1: String Index 8 read FButton1 write FButton1;
    property Field3: Double Index 9 read FField3 write FField3;
  end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    cButton1: TButton;
    CheckBox1: TCheckBox;
    isbool: TEdit;
    cFloatSpinEdit1: TFloatSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    memo1: TMemo;
    cSpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure cButton1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

uses
  ClassInfoU;

procedure TForm1.cButton1Click(Sender: TObject);
var
  mc: TMyClass;
  i: Integer;
begin
  //initialize test class
  mc := TMyClass.Create;
  mc.Description := ' very very very long text'#13#10'in'#13#10'few'#13#10'lines';
  mc.Name := 'test';
  mc.Value := 126437;
  mc.IsBool := True;
  mc.Field3 := 634.589;
  mc.SpinEdit1 := '534';
  mc.FloatSpinEdit1 := FloatToStr(925.23564);
  mc.Qty := 923.01;
  mc.Button1 := 'Success';
  //load data from class
  for i := 0 to ControlCount - 1 do
  begin
    if Controls[i] is TCheckBox then
      TCheckBox(Controls[i]).Checked := GetClassPropertyAsBoolean(mc, TCheckBox(Controls[i]).Caption)
    else if Controls[i] is TLabel then
      Controls[i].Caption := GetClassPropertyAsString(mc, Controls[i].Caption)
    else if Controls[i] is TEdit then
      TEdit(Controls[i]).Text := GetClassPropertyAsString(mc, TEdit(Controls[i]).Text)
    else if Controls[i] is TMemo then
      TMemo(Controls[i]).Lines.Text := GetClassPropertyAsString(mc, Trim(TMemo(Controls[i]).Lines.Text))
    else if Copy(Controls[i].Name, 1, 1) = 'c' then
    begin
      if Controls[i] is TSpinEdit then
        TSpinEdit(Controls[i]).Value := GetClassPropertyAsInteger(mc, Copy(Controls[i].Name, 2))
      else if Controls[i] is TFloatSpinEdit then
        TFloatSpinEdit(Controls[i]).Value := GetClassPropertyAsFloat(mc, Copy(Controls[i].Name, 2))
      else
        Controls[i].Caption := GetClassPropertyAsString(mc, Copy(Controls[i].Name, 2));
    end;
  end;
  //
  mc.Free;
end;

procedure TForm1.Label2Click(Sender: TObject);
begin

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  mc: TMyClass;
  i: Integer;
begin
  //initialize test class
  mc := TMyClass.Create;
  mc.Description := 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.';
  mc.Name := 'test 1234';
  mc.Value := 938103829;
  mc.IsBool := False;
  mc.Field3 := 0;
  mc.SpinEdit1 := '2532';
  mc.FloatSpinEdit1 := FloatToStr(12903.002301);
  mc.Qty := 1034.03;
  mc.Button1 := 'Success';
  //load data from class
  for i := 0 to ControlCount - 1 do
  begin
    if (Controls[i] is TCheckBox) then
      TCheckBox(Controls[i]).Checked := GetClassPropertyAsBoolean(mc, '', Integer(Controls[i].Tag))
    else if (Controls[i] is TLabel) or (Controls[i] is TButton) or (Controls[i] is TEdit) or (Controls[i] is TMemo) then
      Controls[i].Caption := GetClassPropertyAsString(mc, '', Integer(Controls[i].Tag))
    else if Controls[i] is TSpinEdit then
      TSpinEdit(Controls[i]).Value := GetClassPropertyAsInteger(mc, '', Integer(Controls[i].Tag))
    else if Controls[i] is TFloatSpinEdit then
      TFloatSpinEdit(Controls[i]).Value := GetClassPropertyAsFloat(mc, '', Integer(Controls[i].Tag));
  end;
  //
  mc.Free;
end;

end.

